//  Widz_apmon.c
// 
//  This is a hacked version of the Marveloud Wlansniff
//  from the really good HOSTAp driver 
//  it provides the data for
//  Widz_apmon.c
/*
 * Wireless LAN (IEEE 802.11) link-layer frame sniffer
 * Copyright (c) 2001-2002, SSH Communications Security Corp
 * Jouni Malinen <jkm@ssh.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation. See README and COPYING for
 * more details.
 */

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <asm/types.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>   /* The L2 protocols */
#include <linux/if_arp.h>

#include "ieee80211.h"
#include "widz.h"



#include <time.h>
#include <sys/time.h>
 struct tm *timep;
  struct timeval ts;

  time_t  otime;



widz_hdr_t widz_hdr;


frame_control_t *fc1 ;
void init();

/*
 *	for dumping the frame in hex
 */
char dummybuf[20];
char *
hexdump (__u8 * x, int y)
{
  int i = -1;
  while (++i < y)
    sprintf (&dummybuf[(i * 2)], "%02x", x[i]);
  return (dummybuf);
}

char pritty[2];  

/* probe_mon */
void probe_mon();

/* management.c */
int show_frame_management(unsigned int subtype, unsigned char *pos, int len);


enum { BEACONS_NO, BEACONS_ONE_LINE, BEACONS_FULL };
int show_beacons = BEACONS_NO;
int show_only_authen = 0;


const char *wlan_ftype_str(int type)
{
	switch (type) {
	case WLAN_FC_TYPE_DATA:
		return "data";
	case WLAN_FC_TYPE_MGMT:
		return "mgmt";
	case WLAN_FC_TYPE_CTRL:
		return "ctrl";
	default:
		return "unknown";
	}
}

const char *wlan_control_str(int type)
{
	switch (type) {
	case WLAN_FC_STYPE_PSPOLL:
		return "power_save_poll";
	case WLAN_FC_STYPE_RTS:
		return "request_to_send";
	case WLAN_FC_STYPE_CFEND:
		return "contention_free_end";
	case WLAN_FC_STYPE_CFENDACK:
		return "cf_end+cf_ack";
	case WLAN_FC_STYPE_CTS:
		return "clear_to_send";
	case WLAN_FC_STYPE_ACK:
		return "acknowledgement";
	default:
		return "unknown";
	}
}

const char *wlan_management_str(int type)
{
	switch (type) {
	case WLAN_FC_STYPE_ASSOC_REQ:
		return "association_request";
	case WLAN_FC_STYPE_ASSOC_RESP:
		return "association_response";
	case WLAN_FC_STYPE_REASSOC_REQ:
		return "reassociation_request";
	case WLAN_FC_STYPE_REASSOC_RESP:
		return "reassociation_response";
	case WLAN_FC_STYPE_PROBE_REQ:
		return "probe_request";
	case WLAN_FC_STYPE_PROBE_RESP:
		return "probe_response";
	case WLAN_FC_STYPE_BEACON:
		return "beacon";
	case WLAN_FC_STYPE_ATIM:
		return "announcement_traffic_indication_message";
	case WLAN_FC_STYPE_DISASSOC:
		return "disassociation";
	case WLAN_FC_STYPE_AUTH:
		return "authentication";
	case WLAN_FC_STYPE_DEAUTH:
		return "deauthentication";
	default:
		return "unknown";
	}
}

const char *wlan_data_str(int type)
{
	switch (type) {
	case WLAN_FC_STYPE_DATA:
		return "data";
	case WLAN_FC_STYPE_DATA_CFACK:
		return "data+cf-ack";
	case WLAN_FC_STYPE_DATA_CFPOLL:
		return "data+cf-poll";
	case WLAN_FC_STYPE_DATA_CFACKPOLL:
		return "data+cf-ack+cf-poll";
	case WLAN_FC_STYPE_NULLFUNC:
		return "null_function";
	case WLAN_FC_STYPE_CFACK:
		return "cf-ack";
	case WLAN_FC_STYPE_CFPOLL:
		return "cf-poll";
	case WLAN_FC_STYPE_CFACKPOLL:
		return "cf-ack+cf-poll";
	default:
		return "unknown";
	}
}

const char *mac2str(unsigned char *addr)
{
	static char buf[20];
	snprintf(buf, sizeof(buf), "%02x:%02x:%02x:%02x:%02x:%02x",
		 addr[0], addr[1], addr[2], addr[3], addr[4], addr[5]);
	return buf;
}


void show_duration(unsigned int duration)
{
	// duration contains AID - needs some sorting
}

void show_sequence(unsigned int seq)
{
// printf("  frag#=%u  seq#=%u", WLAN_GET_SEQ_FRAG(seq), WLAN_GET_SEQ_SEQ(seq));
}

void show_hdr_management(struct hfa384x_rx_frame *frm)
{
	struct p80211_hdr_data *hdr;

	hdr = (struct p80211_hdr_data *) &frm->frame_control;
	printf("  ");
	show_duration(le_to_host16(hdr->duration_id));
	show_sequence(le_to_host16(hdr->seq_ctrl));
}


struct addr_titles {
	char *a1, *a2, *a3, *a4;
};

static struct addr_titles titles[] = {
	{"DA", "SA", "BSSID", NULL},
	{"DA", "BSSID", "SA", NULL},
	{"BSSID", "SA", "DA", NULL},
	{"RA", "TA", "DA", "SA"}};

void show_hdr_data(struct hfa384x_rx_frame *frm)
{
	struct p80211_hdr_data *hdr;
	unsigned int fc;
	int addr4;

	hdr = (struct p80211_hdr_data *) &frm->frame_control;
	fc = le_to_host16(hdr->frame_control);
	addr4 = (fc & WLAN_FC_TODS) && (fc & WLAN_FC_FROMDS);

}

void show_hdr_rts(struct hfa384x_rx_frame *frm)
{
	struct p80211_hdr_rts *hdr;

	hdr = (struct p80211_hdr_rts *) &frm->frame_control;
	show_duration(le_to_host16(hdr->duration_id));
	/*
	printf("\n  RA=%s", mac2str(hdr->ra));
	printf(" TA=%s\n", mac2str(hdr->ta));
	*/
}

void show_hdr_pspoll(struct hfa384x_rx_frame *frm)
{
	struct p80211_hdr_pspoll *hdr;

	hdr = (struct p80211_hdr_pspoll *) &frm->frame_control;
	printf("  ");
	/* duration_id should always be AID 
	show_duration(le_to_host16(hdr->duration_id));
	printf("\n  BSSID=%s", mac2str(hdr->bssid));
	printf(" TA=%s\n", mac2str(hdr->ta));
	*/
}

void show_hdr_cfend(struct hfa384x_rx_frame *frm)
{
	struct p80211_hdr_cfend *hdr;

	hdr = (struct p80211_hdr_cfend *) &frm->frame_control;
	/* duration_id should always be AID 
	show_duration(le_to_host16(hdr->duration_id));
	printf("\n  RA=%s", mac2str(hdr->ra));
	printf(" BSSID=%s\n", mac2str(hdr->bssid));
	*/
}

void show_hdr_cts(struct hfa384x_rx_frame *frm)
{
	struct p80211_hdr_cts *hdr;

	hdr = (struct p80211_hdr_cts *) &frm->frame_control;
	/*
	printf("  ");
	show_duration(le_to_host16(hdr->duration_id));
	printf("\n  RA=%s\n", mac2str(hdr->ra));
	*/
}

void handle_wlansniffrm(unsigned char *buf, int len, int prism_header)
{
	struct hfa384x_rx_frame frmbuf, *frm;
	int left, used, hdrlen;
	unsigned char *pos;
	unsigned int fc;

	left = len;
	pos = buf;

memset ( &widz_hdr.SSID  , 0, SSID_SIZE);
memset ( widz_hdr.mac1,   0,       6);
memset ( widz_hdr.mac2,   0,       6);
memset ( widz_hdr.mac3,   0,       6);
memset ( widz_hdr.mac4,   0,       6);

		frm = (struct hfa384x_rx_frame *) (buf - 14);

	widz_hdr.frame_control = le_to_host16(frm->frame_control);
	fc = le_to_host16(frm->frame_control);
	hdrlen = 24;
	switch (WLAN_FC_GET_TYPE(fc)) {
	case WLAN_FC_TYPE_DATA:
		if ((fc & WLAN_FC_FROMDS) && (fc & WLAN_FC_TODS))
			hdrlen = 30; /* Addr4 */
		        memcpy( widz_hdr.mac4,&frm->addr4,6);
		break;
	case WLAN_FC_TYPE_CTRL:
		switch (WLAN_FC_GET_STYPE(fc)) {
		case WLAN_FC_STYPE_CTS:
		case WLAN_FC_STYPE_ACK:
			hdrlen = 10;
			break;
		default:
			hdrlen = 16;
			break;
			}
		break;
	}

	if (left < hdrlen) {
		printf("Too short packed (left=%d < hdrlen=%d)\n",
		       left, hdrlen);
		return;
	}

	left -= hdrlen;
	pos += hdrlen;


		gettimeofday(&widz_hdr.ts,NULL);
		widz_hdr.timep=gmtime( &widz_hdr.ts.tv_sec);
		memcpy( widz_hdr.mac1,&frm->addr1,6);
		memcpy( widz_hdr.mac2,&frm->addr2,6);
		memcpy( widz_hdr.mac3,&frm->addr3,6);



//*********************************************************************************
		


	switch (WLAN_FC_GET_TYPE(fc)) {
	case WLAN_FC_TYPE_DATA:
		show_hdr_data(frm);
		break;
	case WLAN_FC_TYPE_MGMT:
		show_hdr_management(frm);
		break;
	case WLAN_FC_TYPE_CTRL:
		switch (WLAN_FC_GET_STYPE(fc)) {
		case WLAN_FC_STYPE_PSPOLL:
			show_hdr_pspoll(frm);
			break;
		case WLAN_FC_STYPE_RTS:
			show_hdr_rts(frm);
			break;
		case WLAN_FC_STYPE_CFEND:
		case WLAN_FC_STYPE_CFENDACK:
			show_hdr_cfend(frm);
			break;
		case WLAN_FC_STYPE_CTS:
		case WLAN_FC_STYPE_ACK:
			show_hdr_cts(frm);
			break;
		}
		break;
	}

	used = 0;
	switch (WLAN_FC_GET_TYPE(fc)) {
	case WLAN_FC_TYPE_MGMT:
		used = show_frame_management(WLAN_FC_GET_STYPE(fc), pos, left);
		break;
	}
	pos += used;
	left -= used;


}


void sniffer(const char *iface)
{
	int s, cnt, arptype;
	struct ifreq ifr;
	struct sockaddr_ll addr;

	s = socket(PF_INET, SOCK_DGRAM, 0);
	if (s < 0) {
		perror("socket[PF_INET,SOCK_DGRAM]");
		exit(-1);
	}
        memset(&ifr, 0, sizeof(ifr));
        snprintf(ifr.ifr_name, sizeof(ifr.ifr_name), "%s", iface);
        if (ioctl(s, SIOCGIFHWADDR, &ifr) != 0) {
		perror("ioctl(SIOCGIFHWADDR)");
		close(s);
		exit(-1);
        }
	arptype = ifr.ifr_hwaddr.sa_family;

        if (ioctl(s, SIOCGIFINDEX, &ifr) != 0) {
		perror("ioctl(SIOCGIFINDEX)");
		close(s);
		exit(-1);
        }
	close(s);

	if (arptype != ARPHRD_IEEE80211 && arptype != ARPHRD_IEEE80211_PRISM) {
		fprintf(stderr, "Unsupported arptype 0x%04x\n", arptype);
		exit(-1);
	}

	s = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_ALL));
	if (s < 0) {
		perror("socket[PF_PACKET,SOCK_RAW]");
		exit(-1);
	}

	memset(&addr, 0, sizeof(addr));
	addr.sll_family = AF_PACKET;
	addr.sll_ifindex = ifr.ifr_ifindex;
	printf("Opening raw packet socket for ifindex %d\n", addr.sll_ifindex);

	if (bind(s, (struct sockaddr *) &addr, sizeof(addr)) < 0) {
		perror("bind");
		close(s);
		exit(-1);
	}

	for (;;) {
		unsigned char buf[8192];
		int len;

		len = recvfrom(s, buf, sizeof(buf), 0, NULL, NULL);
		if (len < 0) {
			perror("recvfrom");
			close(s);
			exit(-1);
		}

		handle_wlansniffrm(buf, len,
				   arptype == ARPHRD_IEEE80211_PRISM ? 1 : 0);
		probe_mon();
	}
}



int main(int argc, char *argv[])
{
	int i;
	const char *iface = NULL;
         fc1 = (frame_control_t *) &widz_hdr.frame_control;

			iface = argv[1];


			init();
	sniffer(iface);
	return 0;
}
